package de.bsvrz.vew.bmvew.bmvew.regel;

import java.util.Vector;

import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.DataDescription;
import de.bsvrz.dav.daf.main.DataNotSubscribedException;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.SendSubscriptionNotConfirmed;
import de.bsvrz.dav.daf.main.SenderRole;
import de.bsvrz.dav.daf.main.Data.TextArray;
import de.bsvrz.dav.daf.main.Data.TextValue;
import de.bsvrz.dav.daf.main.config.Aspect;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.vew.bmvew.bmvew.BetriebsMeldungApp;
import de.bsvrz.vew.bmvew.bmvew.sender.Sender;

/**
 * Die Klasse implementiert das Ausfuehr-Verhalten Verteilen 
 *
 * @version $Revision: 1.2 $ / $Date: 2010/09/14 10:08:10 $ / ($Author: Pittner $)
 *
 * @author Dambach-Werke GmbH
 * @author Timo Pittner
 *
 */
public class AusfuehrenFax implements AktionAusfuehrVerhalten 
{

  /**
   * Der Debugger
   */
  Debug _debug;
  
  /**
   * Das Feld der Parametertexte
   */  
  TextArray _parameter;
  
  /**
   * Der Aktionstext
   */
  TextValue _aktion; 
  

  /**
   * Der Separator zwischen den Nummmern
   */
  final String _separator = " "; 
  
  
  
  /**
   * Konstruktor
   * 
   * @param parameter
   *          Feld der Parametertexte
   * @param aktion
   *          Aktionstext
   */
  public AusfuehrenFax(TextArray parameter, TextValue aktion)
  {
    // TODO Auto-generated constructor stub
    if (aktion == null || parameter == null)
      throw new IllegalArgumentException();
    
    _parameter = parameter;
    _aktion = aktion;
    _debug = Debug.getLogger();
  }

  /* (non-Javadoc)
   * @see de.bsvrz.vew.bmvew.bmvew.regel.AktionAusfuehrVerhalten#ausfuehrenAktion(de.bsvrz.dav.daf.main.ResultData)
   */
  public boolean ausfuehrenAktion(ResultData betriebsMeldung)
  {    
    // TODO Auto-generated method stub
    ClientDavInterface con = BetriebsMeldungApp.getConnection();
    DataModel model = BetriebsMeldungApp.getConnection().getDataModel();
    
    AttributeGroup atg = model.getAttributeGroup("atg.faxVersandAuftrag");
    Aspect asp = model.getAspect("asp.auftrag");
    Data data = con.createData(atg);
    DataDescription dd = new DataDescription(atg, asp);
    
    ConfigurationObject conf = BetriebsMeldungApp.getVersandObjekt();
     
    String absender = betriebsMeldung.getData().getItem("ApplikationsKennung").asTextValue().getText();                  
//    long id = betriebsMeldung.getData().getItem("ApplikationsID").asScaledValue().longValue();
    long nummer = betriebsMeldung.getData().getItem("LaufendeNummer").asScaledValue().longValue();
    long id = BetriebsMeldungApp.getConnection().getLocalApplicationObject().getId();     
//    long nummer = BetriebsMeldungApp.getNextLaufendeNummerEmailFax();
    
//    if (nummer > 0)
//    nummer =- 1;
    
    String text = betriebsMeldung.getData().getItem("MeldungsText").asTextValue().getText();
       
    data.getItem("MeldungsID").getItem("ApplikationsID").asScaledValue().set(id);
    data.getItem("MeldungsID").getItem("LaufendeNummer").asScaledValue().set(nummer);
    
    
    TextArray array = data.getItem("Empfaenger").asTextArray();
    
    array.setLength(_parameter.getLength());

    for (int i = 0; i < array.getLength(); i++)
    {
      array.getTextValue(i).setText(_parameter.getText(i));
    }
   
    data.getItem("Text").asTextValue().setText(text);
    
    // versende Email
    _debug.fine("Aktion -> " + _aktion.getText() + " versende Fax " + data + " für : " + conf.getPid());
    
    Vector<ResultData> sendeDaten = BetriebsMeldungApp.getSendeDaten();
    ResultData res = new ResultData(conf, dd, System.currentTimeMillis(), data);
    
    synchronized (sendeDaten)
    {
      sendeDaten.add(res);        
      sendeDaten.notify();
    }
    
//    Sender sender = new Sender(con, SenderRole.sender());
//    sender.sende(conf, atg, asp, data);
    
    
    
    return true;
  }

}
